#include "stdafx.h"
using namespace GgafCore;
using namespace GgafDxCore;

GgafDxBgmManager::GgafDxBgmManager(const char* prm_manager_name) :
    GgafResourceManager<GgafDxBgm> (prm_manager_name) {
}

GgafDxBgm* GgafDxBgmManager::processCreateResource(char* prm_idstr, void* prm_p) {
    GgafDxBgm* pResourceBgm = NEW GgafDxBgm(prm_idstr);
    return pResourceBgm;
}

void GgafDxBgmManager::updateVolume() {
    while(_is_connecting_resource) {
        Sleep(1);
    }
    GgafDxBgmConnection* pConnection = (GgafDxBgmConnection*)_pFirstConnection;
    while (pConnection) {
        pConnection->fetch()->setVolume(GgafDxSound::_bgm_volume);
        while(_is_connecting_resource) { //ȈՔr
            Sleep(1);
        }
        pConnection = (GgafDxBgmConnection*)(pConnection->getNext());
    }
}

GgafResourceConnection<GgafDxBgm>* GgafDxBgmManager::processCreateConnection(char* prm_idstr, GgafDxBgm* prm_pResource) {
    TRACE3(" GgafDxBgmManager::processCreateConnection "<<prm_idstr<<" 𐶐JnB");
    GgafDxBgmConnection* pConnection = NEW GgafDxBgmConnection(prm_idstr, prm_pResource);
    TRACE3(" GgafDxBgmManager::processCreateConnection "<<prm_idstr<<" 𐶐IB");
    return pConnection;
}
