#include "stdafx.h"
using namespace GgafCore;
using namespace GgafDxCore;

GgafDxSeManager::GgafDxSeManager(const char* prm_manager_name) :
    GgafResourceManager<GgafDxSe> (prm_manager_name) {
}

GgafDxSe* GgafDxSeManager::processCreateResource(char* prm_idstr, void* prm_p) {
    // prm_idstr = "1/laser" ̏ꍇAf}l[W[̃L[ɂ"1/laser"œo^
    // ǂݍwavet@C"laser.wav"ƂB
    // ́Awave𕡐`lŖ炵ꍇAŏ̐lω΁A
    // mۂƎӖB

    GgafDxSe* pResource = NULL;
    char idstr[129];
    strcpy(idstr, prm_idstr);
    char* pT = strtok(idstr, "/" );
    pT = strtok(NULL, "/");
    if (pT == NULL) {
        pResource = NEW GgafDxSe(prm_idstr);
    } else {
        pResource = NEW GgafDxSe(pT);
    }

    return pResource;
}

void GgafDxSeManager::updateVolume() {
    while(_is_connecting_resource) {
        Sleep(1);
    }
    GgafDxSeConnection* pConnection = (GgafDxSeConnection*)_pFirstConnection;
    while (pConnection) {
        pConnection->fetch()->setVolume(GgafDxSound::_se_volume);
        while(_is_connecting_resource) { //ȈՔr
            Sleep(1);
        }
        pConnection = (GgafDxSeConnection*)(pConnection->getNext());
    }
}

GgafResourceConnection<GgafDxSe>* GgafDxSeManager::processCreateConnection(char* prm_idstr, GgafDxSe* prm_pResource) {
    TRACE3(" GgafDxSeManager::processCreateConnection "<<prm_idstr<<" 𐶐JnB");
    GgafDxSeConnection* pConnection = NEW GgafDxSeConnection(prm_idstr, prm_pResource);
    TRACE3(" GgafDxSeManager::processCreateConnection "<<prm_idstr<<" 𐶐IB");
    return pConnection;
}
